#!/usr/bin/env jq -Mf
.[] | 
paths(.) as $idx | 
(.[$idx[0]+1]) as $value |
($classes[][.[0]].attributes[$idx[0]]) as $key | # $classes is expected to be provided to JQ
 if $value != null then
	if $key == null then
		empty
	else
		$key + " = " + 
			(
			if ($value | type) == "array" then 
				if $key == "Seq_id" then
					$value[0] # fallback for Wheat3B which is bugged atm and stores Seq_id as an array (cf. GNP-4394), here only select the first item of the array, considered as the real one (from seqid 1st field in GFF3)
				elif $key == "Type" then
					$value|join(" ")|tostring # transform smthg like weird '[""marker"",""unigene""]' into 'marker unigene'
				elif $key == "Subfeatures" then
					# $value | tostring
					[
						(.. as $recursive_item | # recurses over each item of the array # by the way, not very sure of a correct behaviour in all circumstances...
							if $recursive_item | type == "array" then
								empty
							else
								$recursive_item 
							end
						)
						| tostring
					] |
					join(" ") 
				else
					$value | tostring
				end
			else
				$value | tostring
			end
			) 
			| tostring
	end
else
	null
end
